# 成交记录分析器和场景驱动说明:


<!-- TOC -->

- [成交记录分析器和场景驱动说明:](#成交记录分析器和场景驱动说明)
    - [A. 优化开仓(选股/择时)的行为:](#a-优化开仓选股择时的行为)
        - [对于选股](#对于选股)
        - [对于择时](#对于择时)
    - [B. 优化持仓期行为& 优化卖出时机:](#b-优化持仓期行为-优化卖出时机)
        - [对于选股:](#对于选股)
        - [对于择时:](#对于择时)
    - [C. 总体评价:](#c-总体评价)
    - [后期扩展用途:](#后期扩展用途)
        - [1.实盘状态管理和风险判断](#1实盘状态管理和风险判断)
        - [2.作为标准化的指标,进行机器学习的判断和分析](#2作为标准化的指标进行机器学习的判断和分析)

<!-- /TOC -->

 

考虑一个策略的产生和优化的场景,往往对于优化的行为难以做出有效的评估.

 

对于一个优化动作而言,往往其行为应该表现在成交记录中,对此我们做出如下的分析假设:

## A. 优化开仓(选股/择时)的行为:

1.    开仓后是否导致过滤掉劣质股票(波动率高,收益率低)

2.    持有期内股票的回撤是否下降

3.    持有期内连续上涨的股票是否被错误过滤

4.    如果是正确的股票 是否被买在了半山腰(买入前前3日和前10日涨幅是否过大)

5.    是否是在行情震荡期买入(买入前3日和前10日的收益率方差)

6.    买入是在成交量波动放大的情况下还是在成交量波动减少的情况下买入的

 

通常, 一个较好的开仓优化行为有如下的特点:

 

### 对于选股

1.    不能错误的过滤较好表现的股票

2.    有效的减少了失误买入的情况(及持有期的最大回撤下降,最大回撤天数下降,持有期平均利润上升,持有期连续均涨幅上升)

### 对于择时

1.    不能在上涨尾期买入(前10日涨跌幅和前3日涨跌幅不易过大)

2.    不能在较为震荡和不明确行情下买入(前10日和前3日收益率方差不易过大)

3.    根据策略的不同 判断是否较好的反应了策略的需求(如在成交量萎缩的情况下买入)

 

## B. 优化持仓期行为& 优化卖出时机:

 

1.    持仓期长度是否有预期的改变(如持仓时间过短)

2.    持有期利润是否上升

3.    持有期的最大连续涨幅是否抓住(最大连续涨幅是否上升)

4.    持有期的最大跌幅是否下降

5.    持有期的连续亏损时间是否下降

6.    卖出后是否出现较大的涨幅(卖早了)

7.    卖出后是否行情均方差上升了(卖出后的行情震荡)

8.    卖出后是否有巨额放量/巨额缩量的异常行为

9.    在每一日的组合内股票的盈亏数比例是否上升

 

 

通常, 一个较好的持仓/卖出优化行为有如下的特点:

 

### 对于选股:

持仓期内无法选股,但是可以做T调仓(暂时不支持分析)

 

### 对于择时:

1.    一个较好的持仓/卖出优化 应该具有提升持仓期平均利润的行为

2.    一个较好的持仓/卖出优化应该能抓住尽可能多的利润,减少卖出后的涨幅

3.    一个较好的持仓/卖出优化应该能减少巨额亏损的次数

4.    一个较好的持仓/卖出优化在总体上应该表现为每一日的组合内股票的盈亏数量比例上升

5.    一个较好的持仓卖出优化应该能较好的表达策略意图(如提升持仓时间等等)

 

 

 

## C. 总体评价:

 

一个较好的优化行为应该有如下特点:

1.    表达优化的意图

2.    组合的alpha,beta,shape比率上升,最大回撤减少,胜率提高

3.    组合的每日股票盈亏数量比例提升

 

 

## 后期扩展用途:

 

### 1.实盘状态管理和风险判断

对于某一类型的策略,有一个策略的表现平均值,用以作为实盘的运行判断依据:

如果实盘的表现和回测的表现接近(买入前指标,卖出后指标,持仓期的平均指标),则实盘的预期和回测应较为相近,判断为风险正常期,如果在某一些指标上出现了较大的偏差,如卖出后的涨跌幅变大,说明出现了一些回测时未考虑到的条件和情况,需要进行重新的回测分析,判断为风险异常.

 

### 2.作为标准化的指标,进行机器学习的判断和分析

大量的指标可以作为机器学习的维度,进行一些非线性的数据采集,判断这一类型的策略的总体表现







| 指标              | 用途    |      |
| --------------- | ----- | ---- |
| 持有期长度           | B1    |      |
| 持有期利润           | B2,A3 |      |
| 持有期每日收益方差       | A1,B2 |      |
| 持有期最大连续涨跌幅      | A3,B3 |      |
| 持有期最大连续上涨天数占比   | A3,B3 |      |
| 持有期最大连续回撤       | A1,B4 |      |
| 持有期最大连续回撤天数占比   | A1,B4 |      |
| 持有期行情的成交量方差     | A1,B1 |      |
| 持有期行情的行情方向改变次数  | A1,B1 |      |
|                 |       |      |
| 买入前3日涨跌幅        | A4    |      |
| 买入前3日成交量方差      | A5    |      |
| 买入前3日行情收益方差     | A5    |      |
| 买入前10日涨跌幅       | A4    |      |
| 买入前10日成交量方差     | A5    |      |
| 买入前10日收益方差      | A5    |      |
| 卖出后3日涨跌幅        | B6    |      |
| 卖出后3日成交量方差      | B7,B8 |      |
| 卖出后3日行情收益方差     | B7    |      |
| 卖出后10日涨跌幅       | B6    |      |
| 卖出后10日成交量方差     | B7,B8 |      |
| 卖出后10日收益方差      | B7    |      |
|                 |       |      |
| 总体情况分析          | 对应情况  |      |
| alpha           | C2    |      |
| beta            | C2    |      |
| shape           | C2    |      |
| 最大回撤            | C2    |      |
| 持续期             | C2    |      |
| 年化收益            | C2    |      |
| 波动率             | C2    |      |
| 胜率              | C2    |      |
| 收益期望值           | C2    |      |
| 每日组合内股票的盈利数/组合数 | C3,B9 |      |