
# XTP风控规则说明
<!-- TOC -->

- [Rule1模型：订单股数限制](#rule1模型订单股数限制)
- [Rule2模型：订单占用经纪商金额限制](#rule2模型订单占用经纪商金额限制)
- [Rule9模型：限价委托订单股数限制](#rule9模型限价委托订单股数限制)
- [Rule10模型：市价委托订单股数限制](#rule10模型市价委托订单股数限制)
- [Rule14模型：在指定时间内收到订单次数上限](#rule14模型在指定时间内收到订单次数上限)
- [Rule25模型：下订单被市场拒绝次数限制](#rule25模型下订单被市场拒绝次数限制)
- [Rule26模型：下单被柜台系统拒绝次数限制](#rule26模型下单被柜台系统拒绝次数限制)
- [Rule27模型：在指定时间内下订单被市场拒绝次数上限](#rule27模型在指定时间内下订单被市场拒绝次数上限)
- [Rule38模型：在指定时间内下单被柜台系统拒绝次数上限](#rule38模型在指定时间内下单被柜台系统拒绝次数上限)
- [Rule41模型：累计撤单发出次数限制](#rule41模型累计撤单发出次数限制)
- [Rule42模型：撤单/订单比限制](#rule42模型撤单订单比限制)
- [Rule43模型：在指定时间内某只股票收到订单次数上限](#rule43模型在指定时间内某只股票收到订单次数上限)
- [默认1：可用资金不足](#默认1可用资金不足)
- [默认2：可用仓位不足](#默认2可用仓位不足)
- [默认3：订单报价超过涨跌幅限制](#默认3订单报价超过涨跌幅限制)

<!-- /TOC -->
## Rule1模型：订单股数限制
业务功能描述
为了防止“乌龙指”发出单笔下单股数巨大的订单而设立Rule 1。它将出以每个Account为单位，检查订单指令的股数，不能超过门限值。“订单”包括所有价格类型的开仓单和平仓单。

## Rule2模型：订单占用经纪商金额限制
业务功能描述
为了防止“乌龙指”发出金额巨大的订单而设立Rule 2。它将以每个Account为单位，检查订单指令蕴含的金额价值，不能超过门限值。“订单”包括开仓单和平仓单。

## Rule9模型：限价委托订单股数限制
业务功能描述
为了防止“乌龙指”发出单笔下单股数巨大的订单而设立Rule 9。它只针对限价单，将出以每个Account为单位，检查订单指令的股数，不能超过门限值。“订单”包括所有价格类型的开仓单和平仓单。

## Rule10模型：市价委托订单股数限制
业务功能描述
为了防止“乌龙指”发出单笔下单股数巨大的订单而设立Rule 10。它只针对市价单，将以每个Account为单位，检查订单指令的股数，不能超过门限值。“订单”包括所有价格类型的开仓单和平仓单。

## Rule14模型：在指定时间内收到订单次数上限
业务功能描述
是为了拦截较短时间内，用户爆发式的下单而设立Rule14（往往是下单程序出错引起的）。Rule 14计数用户发来的订单，无论下订单校验是否通过，都会被计数。目前计时设置精度暂定为0.001秒。无论本规则有没有开启，系统都会在后台计算累加值。只统计累加客户正常单、客户done away单，软件done away单；回滚过程中不做统计。
　　本规则会触发“熔断”惩罚，即在发生违规后的一段固定时间里再下单，无论有没有超限，都会继续报告违规（除非把rule校验关闭）；
各个Rule之间的熔断惩罚时间是互相独立的。

## Rule25模型：下订单被市场拒绝次数限制
业务功能描述
Rule25 用于记录市场反馈的订单拒绝次数，初始值为0，每次加1。在计数超限之后，拦截开仓单，放行平仓单和撤单。无论本规则有没有开启，系统都会在后台计算累加值。

## Rule26模型：下单被柜台系统拒绝次数限制
业务功能描述
Rule 26 用于记录风控校验不通过的订单数量。计数超限后对开仓单发出拦截，同时继续累加计数值。无论本规则有没有开启，系统都会在后台计算累加值。

## Rule27模型：在指定时间内下订单被市场拒绝次数上限
业务功能描述
与Rule 25类似，Rule27只是将计数范围从“当天”缩小到一个可由用户配置的时间周期。本规则在市场反馈订单拒绝时计数，只针对开仓单产生拦截。在计数到限额后，仍然可以继续发平仓单和撤单。无论本规则有没有开启，系统都会在后台计算累加值。只统计累加市场正常reject单；回滚过程中不做统计。
    本规则会触发“熔断”惩罚，即在发生违规后的一段固定时间里再发单，无论有没有超限，都会继续报告违规（除非把rule校验关闭）；
各个Rule之间的熔断惩罚时间是互相独立的。

## Rule38模型：在指定时间内下单被柜台系统拒绝次数上限
业务功能描述
与Rule 26类似，Rule38只是将计数范围从“当天”缩小到一个可由用户配置的时间周期。本规则只针对开仓单产生拦截，同时继续累加计数值。对平仓单和撤单全放行，也不计数累加值。每次开启时都会从新开始计数统计。无论本规则有没有开启，系统都会在后台计算累加值。
本规则会触发“熔断”惩罚，即在发生违规后的一段固定时间里再发单，无论有没有超限，都会继续报告违规（除非把rule校验关闭）；
    各个Rule之间的熔断惩罚时间是互相独立的。

## Rule41模型：累计撤单发出次数限制
业务功能描述
Rule41用于对撤单发出次数进行计数，每个Account区分开，初始值为0，每次加1，超过门限值，拦截开仓单。单子全部规则任一校验不通过不会被计数。无论本规则有没有开启，系统都会在后台计算累加值。

## Rule42模型：撤单/订单比限制
业务功能描述
为了防止撤单比例太高而设立Rule 42，每个Account区分开，超过门限值，拦截开仓单。计算方法上是将撤单数量与订单相除，换算成百分比后与门限值比大小，再判断是否应该拦截。本规则在撤单数量>指定数量时有效。

## Rule43模型：在指定时间内某只股票收到订单次数上限
业务功能描述
是为了拦截较短时间内，用户爆发式的下单而设立Rule14（往往是下单程序出错引起的）。Rule 14计数用户发来的某只股票的订单，无论下订单校验是否通过，都会被计数。目前计时设置精度暂定为1秒。无论本规则有没有开启，系统都会在后台计算累加值。只统计累加客户正常单、客户done away单，软件done away单；回滚过程中不做统计。
　　本规则会触发“熔断”惩罚，即在发生违规后的一段固定时间里再下单，无论有没有超限，都会继续报告违规（除非把rule校验关闭）；
各个Rule之间的熔断惩罚时间是互相独立的。

## 默认1：可用资金不足
业务功能描述
可用资金是计算客户权益的重要组成分。为了稳妥，在客户开仓和平仓时都因要冻结股票市值和手续费而扣掉可用资金，等真正成交后再将差价还回来。本模型负责检查可用资金累加值，和“可用资金不足”的拦截信号。

## 默认2：可用仓位不足
业务功能描述
默认规则2在用户下平仓单的平仓手数超过可用仓位股数时，发出拦截。本规则不受校验开关配置的限制，始终有效。
    这里的“可用仓位”指未冻结仓位，是当前持仓股数 - 市场上挂单股数。开仓成交使可用仓位上升；平仓指令发出后，可用仓位下降；平仓指令被市场拒绝、平仓单撤销成功会使可用仓位上升。
用户仓位按照不同类型分为两种：今仓、昨仓。在平仓指令到来时，检查对应仓位的数量。在平仓报单股数>持仓股数时，要拦截。不检查开仓单。

## 默认3：订单报价超过涨跌幅限制
业务功能描述
默认规则3在用户下限价委托订单的报价超过涨跌停板价格时，发出拦截。本规则不受校验开关配置的限制，始终有效。
